﻿package project.ui
{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	public class ScrollBar extends Sprite
	{

		//----------------------------------------------------------
		//
		//   Constructor 
		//
		//----------------------------------------------------------

		public function ScrollBar()
		{
			// 背景の作成
			_bg = new Sprite();
			_bg.graphics.lineStyle(1, 0x6c6c6c);
			_bg.graphics.beginFill(0x222222, 0.5);
			_bg.graphics.drawRoundRect(0.5, 0.5, 600, 12, 12, 12);
			addChild(_bg);

			// つまみの作成
			_trigger = new Sprite();
			_trigger.graphics.beginFill(0x0,0);
			_trigger.graphics.drawRect(0, 0, 200, 12);
			_trigger.graphics.beginFill(0xFFFFFF, 0.3);
			_trigger.graphics.drawRoundRect(3, 3, 193, 7, 6, 6);
			_trigger.buttonMode = true;
			addChild(_trigger);

			// つまみをマウスで押したときのイベントを登録
			_trigger.addEventListener(MouseEvent.MOUSE_DOWN, _onMouseDown);
			_bg.addEventListener(MouseEvent.MOUSE_DOWN, onBgMouseDown);
		}

		//----------------------------------------------------------
		//
		//   Property 
		//
		//----------------------------------------------------------

		//--------------------------------------
		// value 
		//--------------------------------------

		private var _value:Number = 0;

		public function get value():Number
		{
			return _value;
		}

		public function set value(v:Number):void
		{
			// valueに値が代入されたら、つまみの位置を調整
			_value = Math.max(0, Math.min(1, v));
			_trigger.x = _value * (_bg.width - _trigger.width);
		}

		private var _bg:Sprite; // 背景
		private var _trigger:Sprite; // つまみ

		//----------------------------------------------------------
		//
		//   Function 
		//
		//----------------------------------------------------------

		private function _onMouseDown(event:MouseEvent):void
		{
			// ドラッグ開始
			_trigger.startDrag(false, new Rectangle(0, 0, _bg.width - _trigger.width, 0));

			// マウス移動とマウスアップのイベントを登録
			stage.addEventListener(MouseEvent.MOUSE_UP, _onMouseUp);
			addEventListener(Event.ENTER_FRAME, _onMouseMove);
		}

		private function onBgMouseDown(event:MouseEvent):void
		{
			_trigger.x = _bg.mouseX - _trigger.width / 2;
			_trigger.x = Math.max(0, Math.min(_bg.width - _trigger.width, _trigger.x));

			// ドラッグ開始
			_trigger.startDrag(false, new Rectangle(0, 0, _bg.width - _trigger.width, 0));

			// マウス移動とマウスアップのイベントを登録
			stage.addEventListener(MouseEvent.MOUSE_UP, _onMouseUp);
			addEventListener(Event.ENTER_FRAME, _onMouseMove);
		}

		private function _onMouseMove(event:Event):void
		{
			// スクロールの値の更新
			_value = _trigger.x / (_bg.width - _trigger.width);
			// イベント発行
			dispatchEvent(new Event(Event.CHANGE));
		}

		private function _onMouseUp(event:MouseEvent):void
		{
			// ドラッグ停止
			_trigger.stopDrag();

			// マウス移動ととマウスアップのイベントを解除
			stage.removeEventListener(MouseEvent.MOUSE_UP, _onMouseUp);
			removeEventListener(Event.ENTER_FRAME, _onMouseMove);
		}
	}
}
